#include "enums.hpp"
#include "random_keys.hpp"
#include "minion_info.hpp"

#include <unordered_map>
#include <string>

// -----------------------------------------------------------------------------
// THIS FILE IS AUTOGENERATED
// see generate_enum_data.py
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// Tribe information
// -----------------------------------------------------------------------------

const char* tribe_names[] = {
  "None",
  "Murloc",
  "Demon",
  "Mech",
  "Elemental",
  "Beast",
  "Pirate",
  "Dragon",
  "All",
};

// -----------------------------------------------------------------------------
// Minion information
// -----------------------------------------------------------------------------

const MinionInfo minion_info[] = {
  {"(none)", {nullptr,nullptr}, 0, Tribe::None, 0,0, false,false,false,false,false, false,false, false},
  {"Acolyte of C'Thun", {"BGS_106","TB_BaconUps_255"}, 1, Tribe::None, 2,2, true,false,false,false,false, false,true, false},
  {"Alleycat", {"CFM_315","TB_BaconUps_093"}, 1, Tribe::Beast, 1,1, false,false,false,false,false, true,true, false},
  {"Deck Swabbie", {"BGS_055","TB_BaconUps_126"}, 1, Tribe::Pirate, 2,2, false,false,false,false,false, true,true, false},
  {"Dragonspawn Lieutenant", {"BGS_039","TB_BaconUps_146"}, 1, Tribe::Dragon, 2,3, true,false,false,false,false, false,true, false},
  {"Fiendish Servant", {"YOD_026","TB_BaconUps_112"}, 1, Tribe::Demon, 2,1, false,false,false,false,false, false,true, true},
  {"Micro Machine", {"BGS_027","TB_BaconUps_094"}, 1, Tribe::Mech, 1,2, false,false,false,false,false, false,true, false},
  {"Micro Mummy", {"ULD_217","TB_BaconUps_250"}, 1, Tribe::Mech, 1,2, false,false,false,false,false, false,true, false},
  {"Murloc Tidecaller", {"VAN_EX1_509","TB_BaconUps_011"}, 1, Tribe::Murloc, 1,2, false,false,false,false,false, false,true, false},
  {"Murloc Tidehunter", {"EX1_506","TB_BaconUps_003"}, 1, Tribe::Murloc, 2,1, false,false,false,false,false, true,true, false},
  {"Red Whelp", {"BGS_019","TB_BaconUps_102"}, 1, Tribe::Dragon, 1,2, false,false,false,false,false, false,true, false},
  {"Refreshing Anomaly", {"BGS_116","TB_BaconUps_167"}, 1, Tribe::Elemental, 1,3, false,false,false,false,false, true,true, false},
  {"Rockpool Hunter", {"UNG_073","TB_BaconUps_061"}, 1, Tribe::Murloc, 2,3, false,false,false,false,false, true,true, false},
  {"Scallywag", {"BGS_061","TB_BaconUps_141"}, 1, Tribe::Pirate, 2,1, false,false,false,false,false, false,true, true},
  {"Scavenging Hyena", {"EX1_531","TB_BaconUps_043"}, 1, Tribe::Beast, 2,2, false,false,false,false,false, false,true, false},
  {"Sellemental", {"BGS_115","TB_BaconUps_156"}, 1, Tribe::Elemental, 2,2, false,false,false,false,false, false,true, false},
  {"Vulgar Homunculus", {"LOOT_013","TB_BaconUps_148"}, 1, Tribe::Demon, 2,4, true,false,false,false,false, true,true, false},
  {"Wrath Weaver", {"BGS_004","TB_BaconUps_079"}, 1, Tribe::None, 1,3, false,false,false,false,false, false,true, false},
  {"Freedealing Gambler", {"BGS_049","TB_BaconUps_127"}, 2, Tribe::Pirate, 3,3, false,false,false,false,false, false,true, false},
  {"Glyph Guardian", {"BGS_045","TB_BaconUps_115"}, 2, Tribe::Dragon, 2,4, false,false,false,false,false, false,true, false},
  {"Harvest Golem", {"EX1_556","TB_BaconUps_006"}, 2, Tribe::Mech, 2,3, false,false,false,false,false, false,true, true},
  {"Imprisoner", {"BGS_014","TB_BaconUps_113"}, 2, Tribe::Demon, 3,3, true,false,false,false,false, false,true, true},
  {"Kaboom Bot", {"BOT_606","TB_BaconUps_028"}, 2, Tribe::Mech, 2,2, false,false,false,false,false, false,true, true},
  {"Kindly Grandmother", {"KAR_005","TB_BaconUps_004"}, 2, Tribe::Beast, 1,1, false,false,false,false,false, false,true, true},
  {"Menagerie Mug", {"BGS_082","TB_BaconUps_144"}, 2, Tribe::None, 2,2, false,false,false,false,false, true,true, false},
  {"Metaltooth Leaper", {"GVG_048","TB_BaconUps_066"}, 2, Tribe::Mech, 3,3, false,false,false,false,false, true,true, false},
  {"Murloc Warleader", {"EX1_507","TB_BaconUps_008"}, 2, Tribe::Murloc, 3,3, false,false,false,false,false, false,true, false},
  {"Nathrezim Overseer", {"BGS_001","TB_BaconUps_062"}, 2, Tribe::Demon, 2,3, false,false,false,false,false, true,true, false},
  {"Old Murk-Eye", {"EX1_062","TB_BaconUps_036"}, 2, Tribe::Murloc, 2,4, false,false,false,false,false, false,true, false},
  {"Pack Leader", {"BGS_017","TB_BaconUps_086"}, 2, Tribe::None, 2,3, false,false,false,false,false, false,true, false},
  {"Party Elemental", {"BGS_120","TB_BaconUps_160"}, 2, Tribe::Elemental, 3,2, false,false,false,false,false, false,true, false},
  {"Rabid Saurolisk", {"BGS_075","TB_BaconUps_125"}, 2, Tribe::Beast, 3,2, false,false,false,false,false, false,true, false},
  {"Selfless Hero", {"OG_221","TB_BaconUps_014"}, 2, Tribe::None, 2,1, false,false,false,false,false, false,true, true},
  {"Southsea Captain", {"NEW1_027","TB_BaconUps_136"}, 2, Tribe::Pirate, 3,3, false,false,false,false,false, false,true, false},
  {"Spawn of N'Zoth", {"OG_256","TB_BaconUps_025"}, 2, Tribe::None, 2,2, false,false,false,false,false, false,true, true},
  {"Steward of Time", {"BGS_037","TB_BaconUps_107"}, 2, Tribe::Dragon, 3,4, false,false,false,false,false, false,true, false},
  {"Tormented Ritualist", {"BGS_201","TB_BaconUps_257"}, 2, Tribe::None, 2,3, true,false,false,false,false, false,true, false},
  {"Unstable Ghoul", {"FP1_024","TB_BaconUps_118"}, 2, Tribe::None, 1,3, true,false,false,false,false, false,true, true},
  {"Waxrider Togwaggle", {"BGS_035","TB_BaconUps_105"}, 2, Tribe::None, 1,3, false,false,false,false,false, false,true, false},
  {"Yo-Ho-Ogre", {"BGS_060","TB_BaconUps_150"}, 2, Tribe::Pirate, 2,6, false,false,false,false,false, false,true, false},
  {"Arm of the Empire", {"BGS_110","TB_BaconUps_302"}, 3, Tribe::None, 4,5, false,false,false,false,false, false,true, false},
  {"Barrens Blacksmith", {"BAR_073","TB_BaconUps_320"}, 3, Tribe::None, 3,5, false,false,false,false,false, false,true, false},
  {"Bloodsail Cannoneer", {"BGS_053","TB_BaconUps_138"}, 3, Tribe::Pirate, 4,3, false,false,false,false,false, false,true, false},
  {"Bronze Warden", {"BGS_034","TB_BaconUps_149"}, 3, Tribe::Dragon, 2,1, false,true,false,false,false, false,true, false},
  {"Coldlight Seer", {"EX1_103","TB_BaconUps_064"}, 3, Tribe::Murloc, 2,3, false,false,false,false,false, true,true, false},
  {"Crackling Cyclone", {"BGS_119","TB_BaconUps_159"}, 3, Tribe::Elemental, 4,1, false,true,false,true,false, false,true, false},
  {"Crystalweaver", {"CFM_610","TB_BaconUps_070"}, 3, Tribe::None, 5,4, false,false,false,false,false, true,true, false},
  {"Deflect-o-Bot", {"BGS_071","TB_BaconUps_123"}, 3, Tribe::Mech, 3,2, false,false,false,false,false, false,true, false},
  {"Felfin Navigator", {"BT_010","TB_BaconUps_124"}, 3, Tribe::Murloc, 4,4, false,false,false,false,false, true,true, false},
  {"Hangry Dragon", {"BGS_033","TB_BaconUps_104"}, 3, Tribe::Dragon, 4,4, false,false,false,false,false, false,true, false},
  {"Houndmaster", {"DS1_070","TB_BaconUps_068"}, 3, Tribe::None, 4,3, false,false,false,false,false, true,true, false},
  {"Imp Gang Boss", {"BRM_006","TB_BaconUps_030"}, 3, Tribe::Demon, 2,4, false,false,false,false,false, false,true, false},
  {"Infested Wolf", {"OG_216","TB_BaconUps_026"}, 3, Tribe::Beast, 3,3, false,false,false,false,false, false,true, true},
  {"Iron Sensei", {"GVG_027","TB_BaconUps_044"}, 3, Tribe::Mech, 2,2, false,false,false,false,false, false,true, false},
  {"Khadgar", {"DAL_575","TB_BaconUps_034"}, 3, Tribe::None, 2,2, false,false,false,false,false, false,true, false},
  {"Monstrous Macaw", {"BGS_078","TB_BaconUps_135"}, 3, Tribe::Beast, 4,3, false,false,false,false,false, false,true, false},
  {"Rat Pack", {"CFM_316","TB_BaconUps_027"}, 3, Tribe::Beast, 2,2, false,false,false,false,false, false,true, true},
  {"Replicating Menace", {"BOT_312","TB_BaconUps_032"}, 3, Tribe::Mech, 3,1, false,false,false,false,false, false,true, true},
  {"Salty Looter", {"BGS_081","TB_BaconUps_143"}, 3, Tribe::Pirate, 4,4, false,false,false,false,false, false,true, false},
  {"Screwjank Clunker", {"GVG_055","TB_BaconUps_069"}, 3, Tribe::Mech, 2,5, false,false,false,false,false, true,true, false},
  {"Soul Devourer", {"BGS_059","TB_BaconUps_119"}, 3, Tribe::Demon, 3,3, false,false,false,false,false, true,true, false},
  {"Soul Juggler", {"BGS_002","TB_BaconUps_075"}, 3, Tribe::None, 3,3, false,false,false,false,false, false,true, false},
  {"Southsea Strongarm", {"BGS_048","TB_BaconUps_140"}, 3, Tribe::Pirate, 4,3, false,false,false,false,false, false,true, false},
  {"Stasis Elemental", {"BGS_122","TB_BaconUps_161"}, 3, Tribe::Elemental, 4,4, false,false,false,false,false, true,true, false},
  {"Twilight Emissary", {"BGS_038","TB_BaconUps_108"}, 3, Tribe::Dragon, 4,4, true,false,false,false,false, true,true, false},
  {"Warden of Old", {"BGS_200","TB_BaconUps_256"}, 3, Tribe::None, 3,3, false,false,false,false,false, false,true, true},
  {"Annoy-o-Module", {"BOT_911","TB_BaconUps_099"}, 4, Tribe::Mech, 2,4, true,true,false,false,false, false,true, false},
  {"Bigfernal", {"BGS_204","TB_BaconUps_304"}, 4, Tribe::Demon, 4,4, false,false,false,false,false, false,true, false},
  {"Bolvar, Fireblood", {"ICC_858","TB_BaconUps_047"}, 4, Tribe::None, 1,7, false,true,false,false,false, false,true, false},
  {"Cave Hydra", {"LOOT_078","TB_BaconUps_151"}, 4, Tribe::Beast, 2,4, false,false,false,false,true, false,true, false},
  {"Champion of Y'Shaarj", {"BGS_111","TB_BaconUps_301"}, 4, Tribe::None, 4,4, false,false,false,false,false, false,true, false},
  {"Cobalt Scalebane", {"ICC_029","TB_BaconUps_120"}, 4, Tribe::Dragon, 5,5, false,false,false,false,false, false,true, false},
  {"Defender of Argus", {"EX1_093","TB_BaconUps_009"}, 4, Tribe::None, 3,3, false,false,false,false,false, true,true, false},
  {"Drakonid Enforcer", {"BGS_067","TB_BaconUps_117"}, 4, Tribe::Dragon, 3,6, false,false,false,false,false, false,true, false},
  {"Goldgrubber", {"BGS_066","TB_BaconUps_130"}, 4, Tribe::Pirate, 2,2, false,false,false,false,false, false,true, false},
  {"Herald of Flame", {"BGS_032","TB_BaconUps_103"}, 4, Tribe::Dragon, 5,6, false,false,false,false,false, false,true, false},
  {"Junkbot", {"GVG_106","TB_BaconUps_046"}, 4, Tribe::Mech, 1,5, false,false,false,false,false, false,true, false},
  {"Majordomo Executus", {"BGS_105","TB_BaconUps_207"}, 4, Tribe::None, 6,3, false,false,false,false,false, false,true, false},
  {"Mechano-Egg", {"BOT_537","TB_BaconUps_039"}, 4, Tribe::Mech, 0,5, false,false,false,false,false, false,true, true},
  {"Menagerie Jug", {"BGS_083","TB_BaconUps_145"}, 4, Tribe::None, 3,3, false,false,false,false,false, true,true, false},
  {"Primalfin Lookout", {"BGS_020","TB_BaconUps_089"}, 4, Tribe::Murloc, 3,2, false,false,false,false,false, true,true, false},
  {"Qiraji Harbinger", {"BGS_112","TB_BaconUps_303"}, 4, Tribe::None, 5,5, false,false,false,false,false, false,true, false},
  {"Ring Matron", {"DMF_533","TB_BaconUps_309"}, 4, Tribe::Demon, 6,4, true,false,false,false,false, false,true, true},
  {"Ripsnarl Captain", {"BGS_056","TB_BaconUps_139"}, 4, Tribe::Pirate, 4,5, false,false,false,false,false, false,true, false},
  {"Savannah Highmane", {"EX1_534","TB_BaconUps_049"}, 4, Tribe::Beast, 6,5, false,false,false,false,false, false,true, true},
  {"Security Rover", {"BOT_218","TB_BaconUps_041"}, 4, Tribe::Mech, 2,6, false,false,false,false,false, false,true, false},
  {"Siegebreaker", {"EX1_185","TB_BaconUps_053"}, 4, Tribe::Demon, 5,8, true,false,false,false,false, false,true, false},
  {"Toxfin", {"DAL_077","TB_BaconUps_152"}, 4, Tribe::Murloc, 1,2, false,false,false,false,false, true,true, false},
  {"Virmen Sensei", {"CFM_816","TB_BaconUps_074"}, 4, Tribe::None, 4,5, false,false,false,false,false, true,true, false},
  {"Wildfire Elemental", {"BGS_126","TB_BaconUps_166"}, 4, Tribe::Elemental, 7,3, false,false,false,false,false, false,true, false},
  {"Annihilan Battlemaster", {"BGS_010","TB_BaconUps_083"}, 5, Tribe::Demon, 3,1, false,false,false,false,false, true,true, false},
  {"Baron Rivendare", {"FP1_031","TB_BaconUps_055"}, 5, Tribe::None, 1,7, false,false,false,false,false, false,true, false},
  {"Brann Bronzebeard", {"LOE_077","TB_BaconUps_045"}, 5, Tribe::None, 2,4, false,false,false,false,false, false,true, false},
  {"Cap'n Hoggarr", {"BGS_072","TB_BaconUps_133"}, 5, Tribe::Pirate, 6,6, false,false,false,false,false, false,true, false},
  {"Deadly Spore", {"BGS_131","TB_BaconUps_251"}, 5, Tribe::None, 1,1, false,false,true,false,false, false,true, false},
  {"Faceless Taverngoer", {"BGS_113","TB_BaconUps_305"}, 5, Tribe::None, 4,4, false,false,false,false,false, true,true, false},
  {"Ironhide Direhorn", {"TRL_232","TB_BaconUps_051"}, 5, Tribe::Beast, 7,7, false,false,false,false,false, false,true, false},
  {"King Bagurgle", {"BGS_030","TB_BaconUps_100"}, 5, Tribe::Murloc, 6,3, false,false,false,false,false, true,true, true},
  {"Lightfang Enforcer", {"BGS_009","TB_BaconUps_082"}, 5, Tribe::None, 2,2, false,false,false,false,false, false,true, false},
  {"Mal'Ganis", {"GVG_021","TB_BaconUps_060"}, 5, Tribe::Demon, 9,7, false,false,false,false,false, false,true, false},
  {"Mama Bear", {"BGS_021","TB_BaconUps_090"}, 5, Tribe::Beast, 4,4, false,false,false,false,false, false,true, false},
  {"Murozond", {"BGS_043","TB_BaconUps_110"}, 5, Tribe::Dragon, 5,5, false,false,false,false,false, true,true, false},
  {"Mythrax the Unraveler", {"BGS_202","TB_BaconUps_258"}, 5, Tribe::None, 4,4, false,false,false,false,false, false,true, false},
  {"Nat Pagle, Extreme Angler", {"BGS_046","TB_BaconUps_132"}, 5, Tribe::Pirate, 8,5, false,false,false,false,false, false,true, false},
  {"Nomi, Kitchen Nightmare", {"BGS_104","TB_BaconUps_201"}, 5, Tribe::None, 4,4, false,false,false,false,false, false,true, false},
  {"Razorgore, the Untamed", {"BGS_036","TB_BaconUps_106"}, 5, Tribe::Dragon, 2,4, false,false,false,false,false, false,true, false},
  {"Seabreaker Goliath", {"BGS_080","TB_BaconUps_142"}, 5, Tribe::Pirate, 6,7, false,false,false,false,false, false,true, false},
  {"Sneed's Old Shredder", {"BGS_006","TB_BaconUps_080"}, 5, Tribe::Mech, 5,7, false,false,false,false,false, false,true, true},
  {"Strongshell Scavenger", {"ICC_807","TB_BaconUps_072"}, 5, Tribe::None, 2,3, false,false,false,false,false, true,true, false},
  {"Tavern Tempest", {"BGS_123","TB_BaconUps_162"}, 5, Tribe::Elemental, 4,4, false,false,false,false,false, true,true, false},
  {"Voidlord", {"LOOT_368","TB_BaconUps_059"}, 5, Tribe::Demon, 3,9, true,false,false,false,false, false,true, true},
  {"Amalgadon", {"BGS_069","TB_BaconUps_121"}, 6, Tribe::All, 6,6, false,false,false,false,false, true,true, false},
  {"Dread Admiral Eliza", {"BGS_047","TB_BaconUps_134"}, 6, Tribe::Pirate, 6,7, false,false,false,false,false, false,true, false},
  {"Foe Reaper 4000", {"GVG_113","TB_BaconUps_153"}, 6, Tribe::Mech, 6,9, false,false,false,false,true, false,true, false},
  {"Gentle Djinni", {"BGS_121","TB_BaconUps_165"}, 6, Tribe::Elemental, 4,5, true,false,false,false,false, false,true, true},
  {"Ghastcoiler", {"BGS_008","TB_BaconUps_057"}, 6, Tribe::Beast, 7,7, false,false,false,false,false, false,true, true},
  {"Goldrinn, the Great Wolf", {"BGS_018","TB_BaconUps_085"}, 6, Tribe::Beast, 4,4, false,false,false,false,false, false,true, true},
  {"Imp Mama", {"BGS_044","TB_BaconUps_116"}, 6, Tribe::Demon, 6,10, false,false,false,false,false, false,true, false},
  {"Kalecgos, Arcane Aspect", {"BGS_041","TB_BaconUps_109"}, 6, Tribe::Dragon, 4,12, false,false,false,false,false, false,true, false},
  {"Kangor's Apprentice", {"BGS_012","TB_BaconUps_087"}, 6, Tribe::None, 4,8, false,false,false,false,false, false,true, true},
  {"Lieutenant Garr", {"BGS_124","TB_BaconUps_163"}, 6, Tribe::Elemental, 5,1, true,false,false,false,false, false,true, false},
  {"Lil' Rag", {"BGS_100","TB_BaconUps_200"}, 6, Tribe::Elemental, 4,4, false,false,false,false,false, false,true, false},
  {"Maexxna", {"FP1_010","TB_BaconUps_155"}, 6, Tribe::Beast, 2,8, false,false,true,false,false, false,true, false},
  {"Nadina the Red", {"BGS_040","TB_BaconUps_154"}, 6, Tribe::None, 7,4, false,false,false,false,false, false,true, true},
  {"The Tide Razor", {"BGS_079","TB_BaconUps_137"}, 6, Tribe::None, 6,4, false,false,false,false,false, false,true, true},
  {"Zapp Slywick", {"BGS_022","TB_BaconUps_091"}, 6, Tribe::None, 7,10, false,false,false,false,false, false,true, false},
  {"Amalgam", {"TB_BaconShop_HP_033t",nullptr}, 1, Tribe::All, 1,2, false,false,false,false,false, false,false, false},
  {"Big Bad Wolf", {"KAR_005a","TB_BaconUps_004t"}, 1, Tribe::Beast, 3,2, false,false,false,false,false, false,false, false},
  {"Damaged Golem", {"VAN_skele21","TB_BaconUps_006t"}, 1, Tribe::Mech, 2,1, false,false,false,false,false, false,false, false},
  {"Dire Wolf Alpha", {"VAN_EX1_162","TB_BaconUps_088"}, 1, Tribe::Beast, 2,2, false,false,false,false,false, false,false, false},
  {"Emperor Cobra", {"EX1_170",nullptr}, 1, Tribe::Beast, 2,3, false,false,true,false,false, false,false, false},
  {"Fiery Imp", {"DMF_533t","TB_BaconUps_309t"}, 1, Tribe::Demon, 3,2, false,false,false,false,false, false,false, false},
  {"Finkle Einhorn", {"VAN_EX1_finkle",nullptr}, 1, Tribe::None, 3,3, false,false,false,false,false, false,false, false},
  {"Fish of N'Zoth", {"TB_BaconShop_HP_105t","TB_BaconUps_307"}, 1, Tribe::Beast, 1,1, false,false,false,false,false, false,false, false},
  {"Guard Bot", {"BOT_218t","TB_BaconUps_041t"}, 1, Tribe::Mech, 2,3, true,false,false,false,false, false,false, false},
  {"Hench-Clan Squire", {"DAL_743t",nullptr}, 1, Tribe::Murloc, 1,1, false,false,false,false,false, false,false, false},
  {"Hyena", {"EX1_534t","TB_BaconUps_049t"}, 1, Tribe::Beast, 2,2, false,false,false,false,false, false,false, false},
  {"Imp", {"BRM_006t","TB_BaconUps_030t"}, 1, Tribe::Demon, 1,1, false,false,false,false,false, false,false, false},
  {"Ironhide Runt", {"TRL_232t","TB_BaconUps_051t"}, 1, Tribe::Beast, 5,5, false,false,false,false,false, false,false, false},
  {"Jo-E Bot", {"BOT_445t","TB_BaconUps_002t"}, 1, Tribe::Mech, 1,1, false,false,false,false,false, false,false, false},
  {"Mecharoo", {"BOT_445","TB_BaconUps_002"}, 1, Tribe::Mech, 1,1, false,false,false,false,false, false,false, true},
  {"Microbot", {"BOT_312t","TB_BaconUps_032t"}, 1, Tribe::Mech, 1,1, false,false,false,false,false, false,false, false},
  {"Murloc Scout", {"VAN_EX1_506a","TB_BaconUps_003t"}, 1, Tribe::Murloc, 1,1, false,false,false,false,false, false,false, false},
  {"Plant", {"UNG_999t2t1",nullptr}, 1, Tribe::None, 1,1, false,false,false,false,false, false,false, false},
  {"Primalfin", {"UNG_201t","TB_BaconUps_052t"}, 1, Tribe::Murloc, 1,1, false,false,false,false,false, false,false, false},
  {"Rat", {"CFM_316t","TB_BaconUps_027t"}, 1, Tribe::Beast, 1,1, false,false,false,false,false, false,false, false},
  {"Righteous Protector", {"ICC_038","TB_BaconUps_147"}, 1, Tribe::None, 1,1, true,true,false,false,false, false,false, false},
  {"Robosaur", {"BOT_537t","TB_BaconUps_039t"}, 1, Tribe::Mech, 8,8, false,false,false,false,false, false,false, false},
  {"Safeguard", {"DAL_088","TB_BaconUps_040"}, 1, Tribe::Mech, 4,5, true,false,false,false,false, false,false, true},
  {"Sky Pirate", {"BGS_061t","TB_BaconUps_141t"}, 1, Tribe::Pirate, 1,1, false,false,false,false,false, false,false, false},
  {"Snake", {"VAN_EX1_554t",nullptr}, 1, Tribe::Beast, 1,1, false,false,false,false,false, false,false, false},
  {"Spider", {"OG_216a","TB_BaconUps_026t"}, 1, Tribe::Beast, 1,1, false,false,false,false,false, false,false, false},
  {"Tabbycat", {"CFM_315t","TB_BaconUps_093t"}, 1, Tribe::Beast, 1,1, false,false,false,false,false, false,false, false},
  {"Treasure Chest", {"BGS_046t","TB_BaconUps_132t"}, 1, Tribe::None, 0,2, false,false,false,false,false, false,false, false},
  {"Vault Safe", {"DAL_088t2","TB_BaconUps_040t"}, 1, Tribe::Mech, 0,5, true,false,false,false,false, false,false, false},
  {"Voidwalker", {"VAN_CS2_065","TB_BaconUps_059t"}, 1, Tribe::Demon, 1,3, true,false,false,false,false, false,false, false},
  {"Water Droplet", {"BGS_115t",nullptr}, 1, Tribe::Elemental, 2,2, false,false,false,false,false, false,false, false},
  {"Amalgam Explorer", {"ULDA_Finley_HP1t",nullptr}, 2, Tribe::All, 2,2, false,false,false,false,false, false,false, false},
  {"Annoy-o-Tron", {"GVG_085",nullptr}, 2, Tribe::Mech, 1,2, true,true,false,false,false, false,false, false},
  {"Arcane Cannon", {"BGS_077","TB_BaconUps_128"}, 2, Tribe::None, 2,2, false,false,false,false,false, false,false, false},
  {"Molten Rock", {"TB_Baconups_202",nullptr}, 2, Tribe::Elemental, 4,8, true,false,false,false,false, false,false, false},
  {"Mounted Raptor", {"BGS_025","TB_BaconUps_019"}, 2, Tribe::Beast, 3,2, false,false,false,false,false, false,false, true},
  {"Nightmare Amalgam", {"GIL_681",nullptr}, 2, Tribe::All, 3,4, false,false,false,false,false, false,false, false},
  {"Pogo-Hopper", {"BGS_028","TB_BaconUps_077"}, 2, Tribe::Mech, 1,1, false,false,false,false,false, true,false, false},
  {"Zoobot", {"KAR_095","TB_BaconUps_063"}, 2, Tribe::Mech, 3,3, false,false,false,false,false, true,false, false},
  {"Arcane Assistant", {"TB_Baconups_203",nullptr}, 3, Tribe::Elemental, 6,6, false,false,false,false,false, true,false, false},
  {"Cobalt Guardian", {"GVG_062",nullptr}, 3, Tribe::Mech, 6,3, false,false,false,false,false, false,false, false},
  {"Crowd Favorite", {"AT_121","TB_BaconUps_037"}, 3, Tribe::None, 4,4, false,false,false,false,false, false,false, false},
  {"Phalanx Commander", {"ULD_179","TB_BaconUps_038"}, 3, Tribe::None, 4,5, false,false,false,false,false, false,false, false},
  {"Piloted Shredder", {"BGS_023","TB_BaconUps_035"}, 3, Tribe::Mech, 4,3, false,false,false,false,false, false,false, true},
  {"Psych-o-Tron", {"OG_145",nullptr}, 3, Tribe::Mech, 3,4, true,true,false,false,false, false,false, false},
  {"Shifter Zerus", {"BGS_029","TB_BaconUps_095"}, 3, Tribe::None, 1,1, false,false,false,false,false, false,false, false},
  {"The Beast", {"VAN_EX1_577","TB_BaconUps_042"}, 3, Tribe::Beast, 9,7, false,false,false,false,false, false,false, true},
  {"Tortollan Shellraiser", {"UNG_037","TB_BaconUps_031"}, 3, Tribe::None, 2,6, true,false,false,false,false, false,false, true},
  {"Festeroot Hulk", {"GIL_655","TB_BaconUps_033"}, 4, Tribe::None, 2,7, false,false,false,false,false, false,false, false},
  {"Floating Watcher", {"GVG_100","TB_BaconUps_101"}, 4, Tribe::Demon, 4,4, false,false,false,false,false, false,false, false},
  {"Menagerie Magician", {"KAR_702","TB_BaconUps_073"}, 4, Tribe::None, 4,4, false,false,false,false,false, true,false, false},
  {"Piloted Sky Golem", {"BGS_024","TB_BaconUps_050"}, 4, Tribe::Mech, 6,4, false,false,false,false,false, false,false, true},
  {"Su Leadfoot", {"PVPDR_YOP_WarPalT1",nullptr}, 4, Tribe::None, 2,6, false,false,false,false,false, false,false, false},
  {"The Boogeymonster", {"OG_300","TB_BaconUps_058"}, 4, Tribe::None, 6,7, false,false,false,false,false, false,false, false},
  {"Whirlwind Tempest", {"DAL_742","TB_BaconUps_206"}, 4, Tribe::Elemental, 6,6, false,false,false,false,false, false,false, false},
  {"Sated Threshadon", {"UNG_010","TB_BaconUps_052"}, 5, Tribe::Beast, 5,7, false,false,false,false,false, false,false, true},
  {"Argent Braggart", {"SCH_149","TB_BaconUps_308"}, 6, Tribe::None, 1,1, false,false,false,false,false, true,false, false},
  {"Elistra the Immortal", {"BGS_205","TB_BaconUps_306"}, 6, Tribe::None, 4,4, false,true,false,false,false, false,false, false},
  {"Faceless Manipulator", {"VAN_EX1_564",nullptr}, 6, Tribe::None, 3,3, false,false,false,false,false, true,false, false},
  {"Gentle Megasaur", {"BGS_031","TB_BaconUps_084"}, 6, Tribe::Beast, 5,4, false,false,false,false,false, true,false, false},
  {"Pre-nerf Mama Bear", {nullptr,nullptr}, 6, Tribe::Beast, 5,5, false,false,false,false,false, false,false, false},
};

// -----------------------------------------------------------------------------
// Lists of minions
// -----------------------------------------------------------------------------

static const MinionType one_cost_minions[] = {
  MinionType::AcolyteOfCThun,
  MinionType::Alleycat,
  MinionType::FiendishServant,
  MinionType::MurlocTidecaller,
  MinionType::RedWhelp,
  MinionType::RefreshingAnomaly,
  MinionType::Scallywag,
  MinionType::WrathWeaver,
  MinionType::SelflessHero,
  MinionType::Toxfin,
};
MinionType random_one_cost_minion(BattleRNG& rng, int player) {
  return random_element(one_cost_minions, rng, rng_key(RNGType::OneCostMinion, player));
}

static const MinionType two_cost_minions[] = {
  MinionType::DragonspawnLieutenant,
  MinionType::MicroMachine,
  MinionType::MicroMummy,
  MinionType::MurlocTidehunter,
  MinionType::RockpoolHunter,
  MinionType::ScavengingHyena,
  MinionType::VulgarHomunculus,
  MinionType::KindlyGrandmother,
  MinionType::UnstableGhoul,
  MinionType::Khadgar,
};
MinionType random_two_cost_minion(BattleRNG& rng, int player) {
  return random_element(two_cost_minions, rng, rng_key(RNGType::TwoCostMinion, player));
}

static const MinionType four_cost_minions[] = {
  MinionType::OldMurkEye,
  MinionType::PartyElemental,
  MinionType::StewardOfTime,
  MinionType::BloodsailCannoneer,
  MinionType::BronzeWarden,
  MinionType::CracklingCyclone,
  MinionType::Crystalweaver,
  MinionType::DeflectOBot,
  MinionType::FelfinNavigator,
  MinionType::Houndmaster,
  MinionType::InfestedWolf,
  MinionType::ReplicatingMenace,
  MinionType::SaltyLooter,
  MinionType::ScrewjankClunker,
  MinionType::SoulDevourer,
  MinionType::StasisElemental,
  MinionType::WardenOfOld,
  MinionType::AnnoyOModule,
  MinionType::ChampionOfYShaarj,
  MinionType::DefenderOfArgus,
  MinionType::RipsnarlCaptain,
  MinionType::BaronRivendare,
  MinionType::DeadlySpore,
  MinionType::FacelessTaverngoer,
  MinionType::StrongshellScavenger,
  MinionType::LilRag,
};
MinionType random_four_cost_minion(BattleRNG& rng, int player) {
  return random_element(four_cost_minions, rng, rng_key(RNGType::FourCostMinion, player));
}

static const MinionType deathrattle_minions[] = {
  MinionType::FiendishServant,
  MinionType::Scallywag,
  MinionType::HarvestGolem,
  MinionType::Imprisoner,
  MinionType::KaboomBot,
  MinionType::KindlyGrandmother,
  MinionType::SelflessHero,
  MinionType::SpawnOfNZoth,
  MinionType::UnstableGhoul,
  MinionType::InfestedWolf,
  MinionType::RatPack,
  MinionType::ReplicatingMenace,
  MinionType::WardenOfOld,
  MinionType::MechanoEgg,
  MinionType::RingMatron,
  MinionType::SavannahHighmane,
  MinionType::KingBagurgle,
  MinionType::SneedsOldShredder,
  MinionType::Voidlord,
  MinionType::GentleDjinni,
  MinionType::Ghastcoiler,
  MinionType::GoldrinnTheGreatWolf,
  MinionType::KangorsApprentice,
  MinionType::NadinaTheRed,
  MinionType::TheTideRazor,
};
MinionType random_deathrattle_minion(BattleRNG& rng, int player) {
  return random_element(deathrattle_minions, rng, rng_key(RNGType::DeathrattleMinion, player));
}

static const MinionType legendary_minions[] = {
  MinionType::OldMurkEye,
  MinionType::Khadgar,
  MinionType::BolvarFireblood,
  MinionType::BaronRivendare,
  MinionType::BrannBronzebeard,
  MinionType::KingBagurgle,
  MinionType::MalGanis,
  MinionType::SneedsOldShredder,
  MinionType::FoeReaper4000,
  MinionType::GoldrinnTheGreatWolf,
  MinionType::Maexxna,
};
MinionType random_legendary_minion(BattleRNG& rng, int player) {
  return random_element(legendary_minions, rng, rng_key(RNGType::LegendaryMinion, player));
}

// -----------------------------------------------------------------------------
// Hero / hero power information
// -----------------------------------------------------------------------------

const HeroInfo hero_info[] = {
  {"(none)",nullptr,{"(none)",nullptr}},
  {"A. F. Kay","TB_BaconShop_HERO_16",{"Procrastinate","TB_BaconShop_HP_044"}},
  {"Al'Akir","TB_BaconShop_HERO_76",{"Swatting Insects","TB_BaconShop_HP_086"}},
  {"Alexstrasza","TB_BaconShop_HERO_56",{"Queen of Dragons","TB_BaconShop_HP_064"}},
  {"Aranna Starseeker","TB_BaconShop_HERO_59",{"Demon Hunter Training","TB_BaconShop_HP_065"}},
  {"Arch-Villain Rafaam","TB_BaconShop_HERO_45",{"I'll Take That!","TB_BaconShop_HP_053"}},
  {"Bartendotron","TB_BaconShop_HERO_31",{"Skilled Bartender","TB_BaconShop_HP_009"}},
  {"C'Thun","TB_BaconShop_HERO_29",{"Saturday C'Thuns!","TB_BaconShop_HP_104"}},
  {"Captain Eudora","TB_BaconShop_HERO_64",{"Buried Treasure","TB_BaconShop_HP_074"}},
  {"Captain Hooktusk","TB_BaconShop_HERO_67",{"Trash for Treasure","TB_BaconShop_HP_075"}},
  {"Chenvaala","TB_BaconShop_HERO_78",{"Avalanche","TB_BaconShop_HP_088"}},
  {"Dancin' Deryl","TB_BaconShop_HERO_36",{"Hat Trick","TB_BaconShop_HP_042"}},
  {"Deathwing","TB_BaconShop_HERO_52",{"ALL Will Burn!","TB_BaconShop_HP_061"}},
  {"Dinotamer Brann","TB_BaconShop_HERO_43",{"Battle Brand","TB_BaconShop_HP_048"}},
  {"Edwin VanCleef","TB_BaconShop_HERO_01",{"Sharpen Blades","TB_BaconShop_HP_001"}},
  {"Elise Starseeker","TB_BaconShop_HERO_42",{"Lead Explorer","TB_BaconShop_HP_047"}},
  {"Forest Warden Omu","TB_BaconShop_HERO_74",{"Everbloom","TB_BaconShop_HP_082"}},
  {"Fungalmancer Flurgl","TB_BaconShop_HERO_55",{"Gone Fishing","TB_BaconShop_HP_056"}},
  {"Galakrond","TB_BaconShop_HERO_02",{"Galakrond's Greed","TB_BaconShop_HP_011"}},
  {"George the Fallen","TB_BaconShop_HERO_15",{"Boon of Light","TB_BaconShop_HP_010"}},
  {"Giantfin","TB_BaconShop_HERO_19",{"Murloc King","TB_BaconShop_HP_017"}},
  {"Greybough","TB_BaconShop_HERO_95",{"Sprout It Out!","TB_BaconShop_HP_107"}},
  {"Illidan Stormrage","TB_BaconShop_HERO_08",{"Wingmen","TB_BaconShop_HP_069"}},
  {"Infinite Toki","TB_BaconShop_HERO_28",{"Temporal Tavern","TB_BaconShop_HP_028"}},
  {"Jandice Barov","TB_BaconShop_HERO_71",{"Swap, Lock, & Shop It","TB_BaconShop_HP_084"}},
  {"Kael'thas Sunstrider","TB_BaconShop_HERO_60",{"Verdant Spheres","TB_BaconShop_HP_066"}},
  {"Kel'Thuzad","TB_BaconShop_HERO_KelThuzad",{"(none)",nullptr}},
  {"King Mukla","TB_BaconShop_HERO_38",{"Bananarama","TB_BaconShop_HP_038"}},
  {"Lady Vashj","TB_BaconShop_HERO_61",{"Evolving Electricity","TB_BaconShop_HP_067"}},
  {"Lich Baz'hial","TB_BaconShop_HERO_25",{"Graveyard Shift","TB_BaconShop_HP_049"}},
  {"Lord Barov","TB_BaconShop_HERO_72",{"Friendly Wager","TB_BaconShop_HP_081"}},
  {"Lord Jaraxxus","TB_BaconShop_HERO_37",{"Bloodfury","TB_BaconShop_HP_036"}},
  {"Maiev Shadowsong","TB_BaconShop_HERO_62",{"Imprison","TB_BaconShop_HP_068"}},
  {"Malygos","TB_BaconShop_HERO_58",{"Arcane Alteration","TB_BaconShop_HP_052"}},
  {"Millhouse Manastorm","TB_BaconShop_HERO_49",{"Manastorm","TB_BaconShop_HP_054"}},
  {"Millificent Manastorm","TB_BaconShop_HERO_17",{"Tinker","TB_BaconShop_HP_015"}},
  {"Mr. Bigglesworth","TB_BaconShop_HERO_70",{"Kel'Thuzad's Kitty","TB_BaconShop_HP_080"}},
  {"N'Zoth","TB_BaconShop_HERO_93",{"Avatar of N'Zoth","TB_BaconShop_HP_105"}},
  {"Nefarian","TB_BaconShop_HERO_30",{"Nefarious Fire","TB_BaconShop_HP_043"}},
  {"Nozdormu","TB_BaconShop_HERO_57",{"Clairvoyance","TB_BaconShop_HP_063"}},
  {"Patches the Pirate","TB_BaconShop_HERO_18",{"Pirate Parrrrty!","TB_BaconShop_HP_072"}},
  {"Patchwerk","TB_BaconShop_HERO_34",{"All Patched Up","TB_BaconShop_HP_035"}},
  {"Professor Putricide","TB_BaconShop_HERO_20",{"Rage Potion","TB_BaconShop_HP_018"}},
  {"Pyramad","TB_BaconShop_HERO_39",{"Brick by Brick","TB_BaconShop_HP_040"}},
  {"Queen Wagtoggle","TB_BaconShop_HERO_14",{"Wax Warband","TB_BaconShop_HP_037a"}},
  {"Ragnaros the Firelord","TB_BaconShop_HERO_11",{"DIE, INSECTS!","TB_BaconShop_HP_087"}},
  {"Rakanishu","TB_BaconShop_HERO_75",{"Tavern Lighting","TB_BaconShop_HP_085"}},
  {"Reno Jackson","TB_BaconShop_HERO_41",{"Gonna Be Rich!","TB_BaconShop_HP_046"}},
  {"Shudderwock","TB_BaconShop_HERO_23",{"Burbling","TB_BaconShop_HP_022"}},
  {"Silas Darkmoon","TB_BaconShop_HERO_90",{"Come One, Come All!","TB_BaconShop_HP_101"}},
  {"Sindragosa","TB_BaconShop_HERO_27",{"Stay Frosty","TB_BaconShop_HP_014"}},
  {"Sir Finley Mrrgglton","TB_BaconShop_HERO_40",{"Adventure!","TB_BaconShop_HP_057"}},
  {"Skycap'n Kragg","TB_BaconShop_HERO_68",{"Piggy Bank","TB_BaconShop_HP_076"}},
  {"Sylvanas Windrunner","TB_BaconShop_HERO_44",{"Banshee's Blessing","TB_BaconShop_HP_050"}},
  {"Tess Greymane","TB_BaconShop_HERO_50",{"Bob's Burgles","TB_BaconShop_HP_077"}},
  {"The Curator","TB_BaconShop_HERO_33",{"Menagerist","TB_BaconShop_HP_033"}},
  {"The Great Akazamzarak","TB_BaconShop_HERO_21",{"Prestidigitation","TB_BaconShop_HP_020"}},
  {"The Lich King","TB_BaconShop_HERO_22",{"Reborn Rites","TB_BaconShop_HP_024"}},
  {"The Rat King","TB_BaconShop_HERO_12",{"A Tale of Kings","TB_BaconShop_HP_041"}},
  {"Tickatus","TB_BaconShop_HERO_94",{"Prize Wall","TB_BaconShop_HP_106"}},
  {"Tirion Fordring","TB_BaconShop_HERO_47",{"Honorable Warband","TB_BaconShop_HP_051"}},
  {"Trade Prince Gallywix","TB_BaconShop_HERO_10",{"Smart Savings","TB_BaconShop_HP_008"}},
  {"Y'Shaarj","TB_BaconShop_HERO_92",{"Embrace Your Rage","TB_BaconShop_HP_103"}},
  {"Yogg-Saron, Hope's End","TB_BaconShop_HERO_35",{"Puzzle Box","TB_BaconShop_HP_039"}},
  {"Ysera","TB_BaconShop_HERO_53",{"Dream Portal","TB_BaconShop_HP_062"}},
  {"Zephrys, the Great","TB_BaconShop_HERO_91",{"Three Wishes","TB_BaconShop_HP_102"}},
};
// -----------------------------------------------------------------------------
// Minion name-type map
// -----------------------------------------------------------------------------

const std::unordered_map<std::string, MinionType> minion_name_type_map({
{ "(none)", MinionType::None },
{ "Acolyte of C'Thun", MinionType::AcolyteOfCThun },
{ "Alleycat", MinionType::Alleycat },
{ "Deck Swabbie", MinionType::DeckSwabbie },
{ "Dragonspawn Lieutenant", MinionType::DragonspawnLieutenant },
{ "Fiendish Servant", MinionType::FiendishServant },
{ "Micro Machine", MinionType::MicroMachine },
{ "Micro Mummy", MinionType::MicroMummy },
{ "Murloc Tidecaller", MinionType::MurlocTidecaller },
{ "Murloc Tidehunter", MinionType::MurlocTidehunter },
{ "Red Whelp", MinionType::RedWhelp },
{ "Refreshing Anomaly", MinionType::RefreshingAnomaly },
{ "Rockpool Hunter", MinionType::RockpoolHunter },
{ "Scallywag", MinionType::Scallywag },
{ "Scavenging Hyena", MinionType::ScavengingHyena },
{ "Sellemental", MinionType::Sellemental },
{ "Vulgar Homunculus", MinionType::VulgarHomunculus },
{ "Wrath Weaver", MinionType::WrathWeaver },
{ "Freedealing Gambler", MinionType::FreedealingGambler },
{ "Glyph Guardian", MinionType::GlyphGuardian },
{ "Harvest Golem", MinionType::HarvestGolem },
{ "Imprisoner", MinionType::Imprisoner },
{ "Kaboom Bot", MinionType::KaboomBot },
{ "Kindly Grandmother", MinionType::KindlyGrandmother },
{ "Menagerie Mug", MinionType::MenagerieMug },
{ "Metaltooth Leaper", MinionType::MetaltoothLeaper },
{ "Murloc Warleader", MinionType::MurlocWarleader },
{ "Nathrezim Overseer", MinionType::NathrezimOverseer },
{ "Old Murk-Eye", MinionType::OldMurkEye },
{ "Pack Leader", MinionType::PackLeader },
{ "Party Elemental", MinionType::PartyElemental },
{ "Rabid Saurolisk", MinionType::RabidSaurolisk },
{ "Selfless Hero", MinionType::SelflessHero },
{ "Southsea Captain", MinionType::SouthseaCaptain },
{ "Spawn of N'Zoth", MinionType::SpawnOfNZoth },
{ "Steward of Time", MinionType::StewardOfTime },
{ "Tormented Ritualist", MinionType::TormentedRitualist },
{ "Unstable Ghoul", MinionType::UnstableGhoul },
{ "Waxrider Togwaggle", MinionType::WaxriderTogwaggle },
{ "Yo-Ho-Ogre", MinionType::YoHoOgre },
{ "Arm of the Empire", MinionType::ArmOfTheEmpire },
{ "Barrens Blacksmith", MinionType::BarrensBlacksmith },
{ "Bloodsail Cannoneer", MinionType::BloodsailCannoneer },
{ "Bronze Warden", MinionType::BronzeWarden },
{ "Coldlight Seer", MinionType::ColdlightSeer },
{ "Crackling Cyclone", MinionType::CracklingCyclone },
{ "Crystalweaver", MinionType::Crystalweaver },
{ "Deflect-o-Bot", MinionType::DeflectOBot },
{ "Felfin Navigator", MinionType::FelfinNavigator },
{ "Hangry Dragon", MinionType::HangryDragon },
{ "Houndmaster", MinionType::Houndmaster },
{ "Imp Gang Boss", MinionType::ImpGangBoss },
{ "Infested Wolf", MinionType::InfestedWolf },
{ "Iron Sensei", MinionType::IronSensei },
{ "Khadgar", MinionType::Khadgar },
{ "Monstrous Macaw", MinionType::MonstrousMacaw },
{ "Rat Pack", MinionType::RatPack },
{ "Replicating Menace", MinionType::ReplicatingMenace },
{ "Salty Looter", MinionType::SaltyLooter },
{ "Screwjank Clunker", MinionType::ScrewjankClunker },
{ "Soul Devourer", MinionType::SoulDevourer },
{ "Soul Juggler", MinionType::SoulJuggler },
{ "Southsea Strongarm", MinionType::SouthseaStrongarm },
{ "Stasis Elemental", MinionType::StasisElemental },
{ "Twilight Emissary", MinionType::TwilightEmissary },
{ "Warden of Old", MinionType::WardenOfOld },
{ "Annoy-o-Module", MinionType::AnnoyOModule },
{ "Bigfernal", MinionType::Bigfernal },
{ "Bolvar, Fireblood", MinionType::BolvarFireblood },
{ "Cave Hydra", MinionType::CaveHydra },
{ "Champion of Y'Shaarj", MinionType::ChampionOfYShaarj },
{ "Cobalt Scalebane", MinionType::CobaltScalebane },
{ "Defender of Argus", MinionType::DefenderOfArgus },
{ "Drakonid Enforcer", MinionType::DrakonidEnforcer },
{ "Goldgrubber", MinionType::Goldgrubber },
{ "Herald of Flame", MinionType::HeraldOfFlame },
{ "Junkbot", MinionType::Junkbot },
{ "Majordomo Executus", MinionType::MajordomoExecutus },
{ "Mechano-Egg", MinionType::MechanoEgg },
{ "Menagerie Jug", MinionType::MenagerieJug },
{ "Primalfin Lookout", MinionType::PrimalfinLookout },
{ "Qiraji Harbinger", MinionType::QirajiHarbinger },
{ "Ring Matron", MinionType::RingMatron },
{ "Ripsnarl Captain", MinionType::RipsnarlCaptain },
{ "Savannah Highmane", MinionType::SavannahHighmane },
{ "Security Rover", MinionType::SecurityRover },
{ "Siegebreaker", MinionType::Siegebreaker },
{ "Toxfin", MinionType::Toxfin },
{ "Virmen Sensei", MinionType::VirmenSensei },
{ "Wildfire Elemental", MinionType::WildfireElemental },
{ "Annihilan Battlemaster", MinionType::AnnihilanBattlemaster },
{ "Baron Rivendare", MinionType::BaronRivendare },
{ "Brann Bronzebeard", MinionType::BrannBronzebeard },
{ "Cap'n Hoggarr", MinionType::CapnHoggarr },
{ "Deadly Spore", MinionType::DeadlySpore },
{ "Faceless Taverngoer", MinionType::FacelessTaverngoer },
{ "Ironhide Direhorn", MinionType::IronhideDirehorn },
{ "King Bagurgle", MinionType::KingBagurgle },
{ "Lightfang Enforcer", MinionType::LightfangEnforcer },
{ "Mal'Ganis", MinionType::MalGanis },
{ "Mama Bear", MinionType::MamaBear },
{ "Murozond", MinionType::Murozond },
{ "Mythrax the Unraveler", MinionType::MythraxTheUnraveler },
{ "Nat Pagle, Extreme Angler", MinionType::NatPagleExtremeAngler },
{ "Nomi, Kitchen Nightmare", MinionType::NomiKitchenNightmare },
{ "Razorgore, the Untamed", MinionType::RazorgoreTheUntamed },
{ "Seabreaker Goliath", MinionType::SeabreakerGoliath },
{ "Sneed's Old Shredder", MinionType::SneedsOldShredder },
{ "Strongshell Scavenger", MinionType::StrongshellScavenger },
{ "Tavern Tempest", MinionType::TavernTempest },
{ "Voidlord", MinionType::Voidlord },
{ "Amalgadon", MinionType::Amalgadon },
{ "Dread Admiral Eliza", MinionType::DreadAdmiralEliza },
{ "Foe Reaper 4000", MinionType::FoeReaper4000 },
{ "Gentle Djinni", MinionType::GentleDjinni },
{ "Ghastcoiler", MinionType::Ghastcoiler },
{ "Goldrinn, the Great Wolf", MinionType::GoldrinnTheGreatWolf },
{ "Imp Mama", MinionType::ImpMama },
{ "Kalecgos, Arcane Aspect", MinionType::KalecgosArcaneAspect },
{ "Kangor's Apprentice", MinionType::KangorsApprentice },
{ "Lieutenant Garr", MinionType::LieutenantGarr },
{ "Lil' Rag", MinionType::LilRag },
{ "Maexxna", MinionType::Maexxna },
{ "Nadina the Red", MinionType::NadinaTheRed },
{ "The Tide Razor", MinionType::TheTideRazor },
{ "Zapp Slywick", MinionType::ZappSlywick },
{ "Amalgam", MinionType::Amalgam },
{ "Big Bad Wolf", MinionType::BigBadWolf },
{ "Damaged Golem", MinionType::DamagedGolem },
{ "Dire Wolf Alpha", MinionType::DireWolfAlpha },
{ "Emperor Cobra", MinionType::EmperorCobra },
{ "Fiery Imp", MinionType::FieryImp },
{ "Finkle Einhorn", MinionType::FinkleEinhorn },
{ "Fish of N'Zoth", MinionType::FishOfNZoth },
{ "Guard Bot", MinionType::GuardBot },
{ "Hench-Clan Squire", MinionType::HenchClanSquire },
{ "Hyena", MinionType::Hyena },
{ "Imp", MinionType::Imp },
{ "Ironhide Runt", MinionType::IronhideRunt },
{ "Jo-E Bot", MinionType::JoEBot },
{ "Mecharoo", MinionType::Mecharoo },
{ "Microbot", MinionType::Microbot },
{ "Murloc Scout", MinionType::MurlocScout },
{ "Plant", MinionType::Plant },
{ "Primalfin", MinionType::Primalfin },
{ "Rat", MinionType::Rat },
{ "Righteous Protector", MinionType::RighteousProtector },
{ "Robosaur", MinionType::Robosaur },
{ "Safeguard", MinionType::Safeguard },
{ "Sky Pirate", MinionType::SkyPirate },
{ "Snake", MinionType::Snake },
{ "Spider", MinionType::Spider },
{ "Tabbycat", MinionType::Tabbycat },
{ "Treasure Chest", MinionType::TreasureChest },
{ "Vault Safe", MinionType::VaultSafe },
{ "Voidwalker", MinionType::Voidwalker },
{ "Water Droplet", MinionType::WaterDroplet },
{ "Amalgam Explorer", MinionType::AmalgamExplorer },
{ "Annoy-o-Tron", MinionType::AnnoyOTron },
{ "Arcane Cannon", MinionType::ArcaneCannon },
{ "Molten Rock", MinionType::MoltenRock },
{ "Mounted Raptor", MinionType::MountedRaptor },
{ "Nightmare Amalgam", MinionType::NightmareAmalgam },
{ "Pogo-Hopper", MinionType::PogoHopper },
{ "Zoobot", MinionType::Zoobot },
{ "Arcane Assistant", MinionType::ArcaneAssistant },
{ "Cobalt Guardian", MinionType::CobaltGuardian },
{ "Crowd Favorite", MinionType::CrowdFavorite },
{ "Phalanx Commander", MinionType::PhalanxCommander },
{ "Piloted Shredder", MinionType::PilotedShredder },
{ "Psych-o-Tron", MinionType::PsychOTron },
{ "Shifter Zerus", MinionType::ShifterZerus },
{ "The Beast", MinionType::TheBeast },
{ "Tortollan Shellraiser", MinionType::TortollanShellraiser },
{ "Festeroot Hulk", MinionType::FesterootHulk },
{ "Floating Watcher", MinionType::FloatingWatcher },
{ "Menagerie Magician", MinionType::MenagerieMagician },
{ "Piloted Sky Golem", MinionType::PilotedSkyGolem },
{ "Su Leadfoot", MinionType::SuLeadfoot },
{ "The Boogeymonster", MinionType::TheBoogeymonster },
{ "Whirlwind Tempest", MinionType::WhirlwindTempest },
{ "Sated Threshadon", MinionType::SatedThreshadon },
{ "Argent Braggart", MinionType::ArgentBraggart },
{ "Elistra the Immortal", MinionType::ElistraTheImmortal },
{ "Faceless Manipulator", MinionType::FacelessManipulator },
{ "Gentle Megasaur", MinionType::GentleMegasaur },
{ "Pre-nerf Mama Bear", MinionType::PreNerfMamaBear },
});
